# Notation

This page lists basic notations used throughout the documentation. First, let a set of users and items be $\mathcal{U}$ and $\mathcal{I}$, respectively. We then define a set of true observation of items for a user $u \in \mathcal{U}$ by $\mathcal{I}^+_u$ as a subset of $\mathcal{I}$, and $\mathcal{I} \setminus \mathcal{I}^+_u$ is symmetrically denoted by $\mathcal{I}^-_u$. Since a recommender returns permutation of items, $I(u)$ will denote an ordered set of items in $\mathcal{I}$ optimized for $u$ based on a certain scoring procedure. Additionally, an ordered set $I_N(u)$ holds only top-$N$ items of $I(u)$.

In this documentation, a $d \times n$ matrix $A \in \mathbb{R}^{d \times n}$ can also be represented as a set of $n$ columns $\left[\mathbf{a}_1, \mathbf{a}_2, \cdots, \mathbf{a}_n\right]$ where $\mathbf{a}_i$ is a vector in $\mathbb{R}^d$. Here, let $R \in \mathbb{R}^{|\mathcal{U}| \times |\mathcal{I}|}$ be a user-item matrix denoting interactions between users and items. The matrix can be both binary and integer matrix depending on a problem. In case that we have two matrices $A$ and $B$ which have the same number of rows, $\left[A, B \right]$ will indicate horizontal concatenation of them. The matrices $0_{d,n}$ and $I_d$ respectively mean a $d$-by-$n$ zero matrix and $d$-dimensional identity matrix. For a $d$-dimensional vector $\mathbf{x} = (x_1, x_2, \cdots, x_d)$, $\| \cdot \|$ will denote the Euclidean norm of the vector $\| \mathbf{x} \| = \sqrt{\sum_i x^2_i}$. The Frobenius norm of a matrix $A$ is $\|A\|_F = \sqrt{\sum_i \|\mathbf{a}_i\|^2}$, and the operator norm of the matrix is defined as $\|A\| = \sup_{\|\mathbf{x}\|=1} \|A \mathbf{x}\|$.

The notation $\mathrm{nnz}(\mathbf{x})$ and $\mathrm{nnz}(A)$ refer to the number of nonzero elements in a vector $\mathbf{x}$ and matrix $A$, respectively. Finally, $\mathbb{1}_{\mathcal{X}}(x)$ will denote an indicator function which returns 1 if $x \in \mathcal{X}$, and 0 otherwise.